#include <memory>
#include <iostream>
using namespace std;

#include "classY.h"

void weakPtr1() {
   shared_ptr<Y> p1(new Y(3));
   shared_ptr<Y> p2 = p1;
   p1 = shared_ptr<Y>(new Y(4));
   cout << "Ende ";
}// free 3 14


void weakPtr2() {
   shared_ptr<Y> p1(new Y(3));
   weak_ptr<Y> p2 = p1;
   p1 = shared_ptr<Y>(new Y(4)); //free 3 
   cout << "Ende ";
} // }// free 14


void weakPtrBadAccess() {
   shared_ptr<Y> p1(new Y(3));
   weak_ptr<Y> p2 = p1;
   // with this statement program would crash
   // p1 = shared_ptr<Y>(new Y(4)); //free 3 
   cout << " Id " << p2.lock()->getId();
   cout << " Ende ";
} // }// free 14
